package digi.recipeManager;

public enum Config
{
	ExistingRecipes("existing-recipes", 'r'),
	RepairRecipes("repair-recipes", true),
	Language("language-file", "en"),
	PrintCantCraft("print.cantcraft", true),
	PrintNoPermission("print.nopermission", true),
	PrintNoWorld("print.noworld", true),
	PrintNoRepair("print.norepair", true),
	PrintGot("print.got", true),
	PrintLost("print.lost", true),
	PrintNotEnough("print.notenough", true),
	PrintRequires("print.requires", true),
	PrintTooMuch("print.toomuch", true),
	PrintFailure("print.failure", true),
	ReturnBuckets("return-empty.buckets", true),
	ReturnPotions("return-empty.potions", true),
	ReturnBowl("return-empty.bowl", true),
	FuelReturnBuckets("fuel-return-buckets", true),
	FurnaceTicks("furnace-ticks", 1);
	
	private String	path;
	private Object	def;
	
	public boolean	bool;
	public char		character;
	public int		integer;
	public String	string;
	
	private Config(final String path, final Object def)
	{
		this.path = path;
		this.def = def;
	}
	
	protected void reload()
	{
		if(def instanceof Boolean)
		{
			bool = Main.plugin.getConfig().getBoolean(path, (Boolean)def);
			Main.log.fine("  " + path + ": " + bool);
		}
		else if(def instanceof Character)
		{
			character = Main.plugin.getConfig().getString(path, "" + def).charAt(0);
			Main.log.fine("  " + path + ": " + character);
		}
		else if(def instanceof Integer)
		{
			integer = Main.plugin.getConfig().getInt(path, (Integer)def);
			Main.log.fine("  " + path + ": " + integer);
		}
		else if(def instanceof String)
		{
			string = Main.plugin.getConfig().getString(path, (String)def);
			Main.log.fine("  " + path + ": " + string);
		}
	}
}