package digi.recipeManager.data;

import java.util.*;

import org.bukkit.ChatColor;

public class Combine extends Recipe
{
	public List<Item>	ingredients;
	public List<Item>	results;
	
	public Combine(final List<Item> ingredients, final List<Item> results, final Recipe recipeData)
	{
		super(recipeData);
		this.ingredients = ingredients;
		this.results = results;
	}
	
	public Item getRandomResult()
	{
		final int rand = new Random().nextInt(100);
		int chance = 0;
		Item result = null;
		
		for(final Item item : results)
		{
			if((chance += item.chance) > rand)
			{
				result = item;
				break;
			}
		}
		
		return result;
	}
	
	@Override
	public String[] print()
	{
		final StringBuilder items = new StringBuilder();
		boolean first = true;
		
		for(final Item i : ingredients)
		{
			items.append((first ? "" : ChatColor.GRAY + " + ") + ChatColor.BLUE + i.printItemData());
			first = false;
		}
		
		final String[] display = new String[results.size() + 2];
		
		display[0] = ChatColor.GOLD + "" + ChatColor.UNDERLINE + "Workbench shapeless recipe:";
		display[1] = items.toString();
		
		for(int i = 0; i < results.size(); i++)
		{
			display[i + 2] = ChatColor.GREEN + " => " + ChatColor.WHITE + results.get(i).printAuto();
		}
		
		return display;
	}
}