package digi.recipeManager.data;

import java.util.Arrays;

import org.bukkit.entity.Player;

/*
 * Thanks to nisovin for this class
 * 
 * Link: http://forums.bukkit.org/threads/experienceutils-make-giving-taking-exp-a-bit-more-intuitive.54450/#post-1067480
 */

public class Exp
{
	private static final int	MAX_LEVEL_SUPPORTED			= 150;
	private static final int	xpRequiredForNextLevel[]	= new int[MAX_LEVEL_SUPPORTED];
	private static final int	xpTotalToReachLevel[]		= new int[MAX_LEVEL_SUPPORTED];
	
	static
	{
		xpTotalToReachLevel[0] = 0;
		int incr = 7;
		
		for(int i = 1; i < xpTotalToReachLevel.length; i++)
		{
			xpRequiredForNextLevel[i - 1] = incr;
			xpTotalToReachLevel[i] = xpTotalToReachLevel[i - 1] + incr;
			incr += (i % 2 == 0) ? 4 : 3;
		}
	}
	
	public static void changeExp(final Player player, final int amt)
	{
		int xp = getCurrentExp(player) + amt;
		
		if(xp < 0)
			xp = 0;
		
		final int curLvl = player.getLevel();
		final int newLvl = getCurrentLevel(xp);
		
		if(curLvl != newLvl)
			player.setLevel(newLvl);
		
		final float pct = ((float)(xp - xpTotalToReachLevel[newLvl]) / (float)xpRequiredForNextLevel[newLvl]);
		player.setExp(pct);
	}
	
	public static int getCurrentExp(final Player player)
	{
		final int lvl = player.getLevel();
		return xpTotalToReachLevel[lvl] + (int)(xpRequiredForNextLevel[lvl] * player.getExp());
	}
	
	public static boolean hasExp(final Player player, final int amt)
	{
		return getCurrentExp(player) >= amt;
	}
	
	public static int getCurrentLevel(final int exp)
	{
		if(exp <= 0)
			return 0;
		final int pos = Arrays.binarySearch(xpTotalToReachLevel, exp);
		return pos < 0 ? -pos - 2 : pos;
	}
}

/*
 *		Thanks to feildmaster for the original implementation.
 *		Thanks to Southpaw018 for the workaround for the enchant/die xp loss problem.
 *		And thanks to desht for gathering both into one class.
 *
 *		I only changed the codes around to fit my other codes
 */
/*
public class Exp
{
	private final Player	player;
	
	public Exp(final Player player)
	{
		this.player = player;
	}
	
	public void setExp(final int exp)
	{
		player.setExp(0);
		player.setLevel(0);
		player.setTotalExperience(0);
		
		if(exp <= 0)
			return;
		
		giveExp(exp);
	}
	
	public void giveExp(int exp)
	{
		if(Events.playerExpRecalc.contains(player.getName()))
			recalcTotalExp();
		
		while(exp > 0)
		{
			int xp = getExpToLevel() - getExp();
			
			if(xp > exp)
				xp = exp;
			
			player.giveExp(xp);
			exp -= xp;
		}
	}
	
	public void takeExp(final int exp, final boolean fromTotal)
	{
		if(Events.playerExpRecalc.contains(player.getName()))
			recalcTotalExp();
		
		int xp = getTotalExp(false);
		
		if(fromTotal)
			xp -= exp;
		
		else
		{
			int m = getExp() - exp;
			
			if(m < 0)
				m = 0;
			
			xp -= getExp() + m;
		}
		
		setExp(xp);
	}
	
	// Get experience functions
	public int getExp()
	{
		return (int)(getExpToLevel() * player.getExp());
	}
	
	public int getTotalExp(final boolean recalc)
	{
		if(recalc)
			recalcTotalExp();
		
		return player.getTotalExperience();
	}
	
	public int getLevel()
	{
		return player.getLevel();
	}
	
	public int getExpToLevel()
	{
		return getExpToLevel(getLevel());
	}
	
	public int getExpToLevel(final int i)
	{
		return 7 + (i * 7 >> 1);
	}
	
	public void recalcTotalExp()
	{
		int total = getExp();
		
		for(int i = 0; i < player.getLevel(); i++)
		{
			total += getExpToLevel(i);
		}
		
		player.setTotalExperience(total);
	}
}
*/